#include <pspkernel.h>
#include <pspdisplay.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <pspmoduleinfo.h>
#include <psputility.h>
#include <pspgu.h>
#include <pspgum.h>

#include <psputility_osk.h>
#include "dumb_frotz.h"

#ifndef MSDOS_16BIT
#define cdecl
#endif

extern void interpret (void);
extern void init_memory (void);
extern void init_undo (void);
extern void reset_memory (void);

/* Story file name, id number and size */

char *story_name = 0;

enum story story_id = UNKNOWN;
long story_size = 0;

/* Story file header data */

zbyte h_version = 0;
zbyte h_config = 0;
zword h_release = 0;
zword h_resident_size = 0;
zword h_start_pc = 0;
zword h_dictionary = 0;
zword h_objects = 0;
zword h_globals = 0;
zword h_dynamic_size = 0;
zword h_flags = 0;
zbyte h_serial[6] = { 0, 0, 0, 0, 0, 0 };
zword h_abbreviations = 0;
zword h_file_size = 0;
zword h_checksum = 0;
zbyte h_interpreter_number = 0;
zbyte h_interpreter_version = 0;
zbyte h_screen_rows = 0;
zbyte h_screen_cols = 0;
zword h_screen_width = 0;
zword h_screen_height = 0;
zbyte h_font_height = 1;
zbyte h_font_width = 1;
zword h_functions_offset = 0;
zword h_strings_offset = 0;
zbyte h_default_background = 0;
zbyte h_default_foreground = 0;
zword h_terminating_keys = 0;
zword h_line_width = 0;
zbyte h_standard_high = 1;
zbyte h_standard_low = 0;
zword h_alphabet = 0;
zword h_extension_table = 0;
zbyte h_user_name[8] = { 0, 0, 0, 0, 0, 0, 0, 0 };

zword hx_table_size = 0;
zword hx_mouse_x = 0;
zword hx_mouse_y = 0;
zword hx_unicode_table = 0;

/* Stack data */

zword stack[STACK_SIZE];
zword *sp = 0;
zword *fp = 0;
zword frame_count = 0;

/* IO streams */

bool ostream_screen = TRUE;
bool ostream_script = FALSE;
bool ostream_memory = FALSE;
bool ostream_record = FALSE;
bool istream_replay = FALSE;
bool message = FALSE;

/* Current window and mouse data */

int cwin = 0;
int mwin = 0;

int mouse_y = 0;
int mouse_x = 0;

/* Window attributes */

bool enable_wrapping = FALSE;
bool enable_scripting = FALSE;
bool enable_scrolling = FALSE;
bool enable_buffering = FALSE;

/* User options */

/*
int option_attribute_assignment = 0;
int option_attribute_testing = 0;
int option_context_lines = 0;
int option_object_locating = 0;
int option_object_movement = 0;
int option_left_margin = 0;
int option_right_margin = 0;
int option_ignore_errors = 0;
int option_piracy = 0;
int option_undo_slots = MAX_UNDO_SLOTS;
int option_expand_abbreviations = 0;
int option_script_cols = 80;
int option_save_quetzal = 1;
*/

int option_sound = 1;
char *option_zcode_path;


/* Size of memory to reserve (in bytes) */

long reserve_mem = 0;



static unsigned int __attribute__((aligned(16))) list[262144];

/* Define the module info section */
PSP_MODULE_INFO("MsgDialog Sample", 0, 1, 0);

#define printf pspDebugScreenPrintf

/* Exit callback */
int exit_callback(int arg1, int arg2, void *common)
{
    sceKernelExitGame();
    return 0;
}

/* Callback thread */
int CallbackThread(SceSize args, void *argp)
{
    int cbid;
    cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
    sceKernelRegisterExitCallback(cbid);
    sceKernelSleepThreadCB();

    return 0;
}

/* Sets up the callback thread and returns its thread id */
int SetupCallbacks(void)
{
    int thid = 0;
    thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
    if (thid >= 0)
        sceKernelStartThread(thid, 0, 0);
    return thid;
}



#define BUF_WIDTH (512)
#define SCR_WIDTH (480)
#define SCR_HEIGHT (272)
#define PIXEL_SIZE (4) /* change this if you change to another screenmode */
#define FRAME_SIZE (BUF_WIDTH * SCR_HEIGHT * PIXEL_SIZE)
#define ZBUF_SIZE (BUF_WIDTH SCR_HEIGHT * 2) /* zbuffer seems to be 16-bit? */

void SetupGu()
{
    sceGuInit();

    sceGuStart(GU_DIRECT,list);
    sceGuDrawBuffer(GU_PSM_8888,(void*)0,BUF_WIDTH);
    sceGuDispBuffer(SCR_WIDTH,SCR_HEIGHT,(void*)0x88000,BUF_WIDTH);
    sceGuDepthBuffer((void*)0x110000,BUF_WIDTH);
    sceGuOffset(2048 - (SCR_WIDTH/2),2048 - (SCR_HEIGHT/2));
    sceGuViewport(2048,2048,SCR_WIDTH,SCR_HEIGHT);
    sceGuDepthRange(0xc350,0x2710);
    sceGuScissor(0,0,SCR_WIDTH,SCR_HEIGHT);
    sceGuEnable(GU_SCISSOR_TEST);
    sceGuDepthFunc(GU_GEQUAL);
    sceGuEnable(GU_DEPTH_TEST);
    sceGuFrontFace(GU_CW);
    sceGuShadeModel(GU_SMOOTH);
    sceGuEnable(GU_CULL_FACE);
    sceGuEnable(GU_CLIP_PLANES);
    sceGuFinish();
    sceGuSync(0,0);
   
    sceDisplayWaitVblankStart();
    sceGuDisplay(GU_TRUE);
}


void DrawStuff(void)
{
    sceGuStart(GU_DIRECT,list);
    sceGuClearDepth(0);
    sceGuClear(GU_COLOR_BUFFER_BIT|GU_DEPTH_BUFFER_BIT);
    sceGuFinish();
    sceGuSync(0,0);
}


int keyboard(char *input){
   
   int done=0;

   // INIT OSK
   unsigned short intext[128]  = { 0 }; // text already in the edit box on start
   unsigned short outtext[128] = { 0 }; // text after input
   unsigned short desc[128]    = { 'E', 'n', 't', 'e', 'r', ' ', 'T', 'e', 'x', 't', 0 }; // description

   

   SceUtilityOskData data;
   memset(&data, 0, sizeof(data));
   data.language = 2; // english
   data.lines = 1; // just one line
   data.unk_24 = 1; // set to 1
   data.desc = desc;
   data.intext = intext;
   data.outtextlength = 128; // sizeof(outtext) / sizeof(unsigned short)
   data.outtextlimit = 50; // just allow 50 chars
   data.outtext = (unsigned short*)outtext;

   SceUtilityOskParams osk;
   memset(&osk, 0, sizeof(osk));
   osk.size = sizeof(osk);
   osk.language = 1;
   osk.buttonswap = 1; //X button: 1
   osk.unk_12 = 17;
   osk.unk_16 = 19; //tester a 1 pour les chiffres
   osk.unk_20 = 18;
   osk.unk_24 = 16;
   osk.unk_48 = 1;
   osk.data = &data;


   int rc = sceUtilityOskInitStart(&osk);
   if(rc) {
      return 0;
   }

   while(!done) {
      
      DrawStuff(); 

      switch(sceUtilityOskGetStatus()) {
         case PSP_OSK_INIT :
            break;
         case PSP_OSK_VISIBLE :
            sceUtilityOskUpdate(2); // 2 is taken from ps2dev.org recommendation
            break;
         case PSP_OSK_QUIT :
            sceUtilityOskShutdownStart();
            break;
         case PSP_OSK_FINISHED :
            done = 1;
            break;
         case PSP_OSK_NONE :
         default :
            break;
      }

      int i,j=0;
      for(i = 0; data.outtext[i]; i++) {

         if (data.outtext[i]!='\0' && data.outtext[i]!='\n' && data.outtext[i]!='\r'){
            input[j] = data.outtext[i];
            j++;
         }
      }

      input[j]='\n';

      /**/
      sceDisplayWaitVblankStart();
      sceGuSwapBuffers();
   }
   return 1;
}

void z_piracy (void)
{

    branch (!f_setup.piracy);

}/* z_piracy */

/* list contents of the directory */
void listDir(char *path) {
    int fd;
    SceIoDirent entry;
    memset(&entry, 0, sizeof(SceIoDirent));
    fd = sceIoDopen(path);
    if (fd) {
            while (sceIoDread(fd, &entry) > 0) {
            printf("%s\n", entry.d_name);
        }
        sceIoDclose(fd);
    }
}

/* main routine */
int main(int argc, char *argv[])
{
   char input[128]="";

   pspDebugScreenInit();
   pspDebugScreenClear();

    SetupCallbacks();

    printf("Select a wireless keyboard\n");
    printf("==========================================================\n\n");
    printf("             press TRIANGLE for PalmUniversal\n\n\n");
    printf("press SQUARE for PalmWireless     press CIRCLE for TargusUniv\n");
    keyboardType=pressButton();

//    keyboardType=3;
//  SetupGu();

   // show the files to user
   listDir("ms0:/PSP/GAME/PSPIRFROTZ");
   printf("\nOpen which file: ");
   getlineNOCR(input);

/* frotz code start*/

    os_init_setup ();

printf("after setup\n");

    argc=1;
    argv[0]=input;
    argv[1]=input;

    os_process_arguments (argc, argv);

printf("after args\n");

    init_buffer ();

printf("after init buffer\n");

    init_err ();

printf("after init err\n");

    init_memory ();

printf("after init mem\n");

    init_process ();

printf("after init_process\n");

    init_sound ();

printf("after init_sound\n");

    os_init_screen ();

printf("after init_screen\n");

    init_undo ();

printf("after init_undo\n");

    z_restart ();

printf("after z_restart\n");
   pspDebugScreenClear();
   pspDebugScreenSetXY(0,0);
    interpret ();

printf("after interpret\n");

    reset_memory ();

printf("after reset_memory\n");

    os_reset_screen ();

printf("after reset screen\n");

/* frotz code ends */
   
//    keyboard(input);
   

//   printf("osk return:\n\n%s\n", input);

   sceKernelDelayThread(10000000);
   sceKernelExitGame();
    return 0;
}

